Attribute VB_Name = "mdlArchivos"
Option Explicit

Declare Function ShellExecute Lib "shell32.DLL" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long


Public Function NombreDeArchivo(strNombreCompleto As String) As String
'Quita el path que antecede al nombre del archivo en strNombreCompleto
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intUltimaBarra As Integer
intUltimaBarra = 0
Do
  intUltimaBarra = InStr(intUltimaBarra + 1, strNombreCompleto, "\")
Loop While (InStr(intUltimaBarra + 1, strNombreCompleto, "\") <> 0)
NombreDeArchivo = Mid(strNombreCompleto, intUltimaBarra + 1, Len(strNombreCompleto) - intUltimaBarra + 1)
End Function


Public Function NombreSinExtension(strNombre As String) As String
'Quita la extensin despus del ltimo "." a continuacin del nombre del archivo de strNombre
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intUltimoPunto As Integer
intUltimoPunto = 0
Do
  intUltimoPunto = InStr(intUltimoPunto + 1, strNombre, ".")
Loop While (InStr(intUltimoPunto + 1, strNombre, ".") <> 0)
NombreSinExtension = Mid(strNombre, 1, intUltimoPunto - 1)
End Function


Public Function Ruta(strNombreCompleto As String) As String
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim strAux As String
If (strNombreCompleto = "") Then
  strAux = ""
Else
  strAux = Mid(strNombreCompleto, 1, Len(strNombreCompleto) - Len(NombreDeArchivo(strNombreCompleto)) - 1)
End If
Ruta = strAux
End Function


Public Function ExisteArchivo(strArchivo As String) As Boolean
'Devuelve un valor booleano en funcin de la existencia o no de strArchivo
On Error GoTo ErrorEnExisteArchivo
Dim intNumArch As Integer
intNumArch = FreeFile
Open strArchivo For Input As intNumArch
Close intNumArch
ExisteArchivo = True

Exit Function

ErrorEnExisteArchivo:
  Select Case Err.Number
    Case 53
      'No existe el archivo
      ExisteArchivo = False
    Case Else
      ExisteArchivo = False
  End Select
End Function


Public Sub AbrirArchivo(f As Form, strArchivo As String)
'Funcin para abrir un archivo cuya extensin est asociada con algn
'soft instalado (por ej., .htm o .pdf), o tambin una pgina de Internet
' Por ejemplo:  AbrirArchivo Me, "c:\manual.pdf"
' o:            AbrirArchivo Me, "http://www.antoniosacco.net"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
ShellExecute f.hWnd, vbNullString, strArchivo, vbNullString, vbNullString, vbNormalFocus
End Sub


Public Sub SepararPorDosPuntos(strCadena As String, ByRef strPrimeraParte As String, ByRef strSegundaParte As String)
'Devuelve la primera parte de "strCadena", hasta los ":", en "strPrimeraParte", y lo siguiente en "strSegundaParte"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intPos As Integer
intPos = InStr(strCadena, ":")
If (intPos > 0) Then
  strPrimeraParte = Mid(strCadena, 1, intPos - 1)
  strSegundaParte = Mid(strCadena, intPos + 1, Len(strCadena) - intPos)
  strSegundaParte = Trim(strSegundaParte)
Else
  strPrimeraParte = ""
  strSegundaParte = ""
End If
End Sub


Public Sub LeerArchivoINI()
'Lee los datos de inicializacin, del archivo "Sin ttulo.bdo"
On Error GoTo ErrorEnLeerArchivoIni
Dim intNumArch As Integer, strCadenaLeida As String, strAux1 As String, strAux2 As String
intNumArch = FreeFile
Open App.Path & "\Sin ttulo.bdo" For Input As intNumArch
Input #intNumArch, strCadenaLeida 'Lee el nombre y versin del programa
Input #intNumArch, strCadenaLeida 'Lee strIdioma
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strIdioma = strAux2
Input #intNumArch, strCadenaLeida 'Lee strEjecutarAutomaticamente
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strEjecutarAutomaticamente = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnMostrarAyudaAlInicio
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnMostrarAyudaAlInicio = strAux2
Input #intNumArch, strCadenaLeida 'Lee intTiempoBarrido
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intTiempoBarrido = Val(strAux2)
Input #intNumArch, strCadenaLeida 'Lee intTiempoPuntosGrabados
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intTiempoPuntosGrabados = Val(strAux2)
Input #intNumArch, strCadenaLeida 'Lee blnMostrarUbicAlCambiarSec
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnMostrarUbicAlCambiarSec = strAux2

Close intNumArch
Exit Sub

CargaPorDefectoArchivoINI:
'Establece valores iniciales por defecto (ya que no se encontr "Sin ttulo.bdo")
strIdioma = "Espaol"
strEjecutarAutomaticamente = "No*"
blnMostrarAyudaAlInicio = True
intTiempoBarrido = 10
intTiempoPuntosGrabados = 20
blnMostrarUbicAlCambiarSec = False
Close intNumArch
Exit Sub

ErrorEnLeerArchivoIni:
  Select Case Err.Number
    Case 53 'No existe el archivo "Sin ttulo.bdo"
      Resume CargaPorDefectoArchivoINI
    Case 62 'El archivo "Sin ttulo.bdo" tiene menos lneas que las necesarias
      Resume CargaPorDefectoArchivoINI
    Case Else
      Resume CargaPorDefectoArchivoINI
  End Select
End Sub


Public Sub GuardarArchivoINI()
'Guarda los datos de inicializacin, en "Sin ttulo.bdo"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch As Integer
Dim strAux As String
intNumArch = FreeFile
Open App.Path & "\Sin ttulo.bdo" For Output As intNumArch

strAux = "Barrido, versin: " & App.Major & "." & App.Minor
If App.Revision > 0 Then strAux = strAux & "." & App.Revision
Write #intNumArch, strAux
Write #intNumArch, "Idioma: " & strIdioma
Write #intNumArch, "Ejecutar automticamente: " & strEjecutarAutomaticamente
Write #intNumArch, "Mostrar ayuda al inicio: " & blnMostrarAyudaAlInicio
Write #intNumArch, "Tiempo de barrido: " & intTiempoBarrido
Write #intNumArch, "Tiempo para mostrar la ubic. de puntos grabados: " & intTiempoPuntosGrabados
Write #intNumArch, "Mostrar ubicacin de los puntos al cambiar la secuencia: " & blnMostrarUbicAlCambiarSec
End Sub


Public Sub GuardarSecuencias(strArchivo As String)
'Guarda las secuencias de puntos y sus datos de configuracin en el archivo .bdo "strArchivo"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch, intAux, intAux2 As Integer
Dim strAux As String
intNumArch = FreeFile
Open strArchivo For Output As intNumArch

strAux = "Barrido, versin: " & App.Major & "." & App.Minor
If App.Revision > 0 Then strAux = strAux & "." & App.Revision
Write #intNumArch, strAux
Write #intNumArch, "Idioma: " & strIdioma
Write #intNumArch, "Ejecutar automticamente: " & strEjecutarAutomaticamente
Write #intNumArch, "Mostrar ayuda al inicio: " & blnMostrarAyudaAlInicio
Write #intNumArch, "Tiempo de barrido: " & intTiempoBarrido
Write #intNumArch, "Tiempo para mostrar la ubic. de puntos grabados: " & intTiempoPuntosGrabados
Write #intNumArch, "Mostrar ubicacin de los puntos al cambiar la secuencia: " & blnMostrarUbicAlCambiarSec
Write #intNumArch, "Cantidad de secuencias: " & intCantidadDeSecuencias
For intAux = 1 To intCantidadDeSecuencias
  Write #intNumArch, "Cantidad de puntos de la secuencia " & intAux & ": " & intCantidadDePuntosSecuencia(intAux)
Next intAux
For intAux = 1 To intCantidadDeSecuencias
  For intAux2 = 1 To intCantidadDePuntosSecuencia(intAux)
    Write #intNumArch, "Secuencia " & intAux & ", punto " & intAux2 & ", X: " & intPunto(intAux, intAux2, 1)
    Write #intNumArch, "Secuencia " & intAux & ", punto " & intAux2 & ", Y: " & intPunto(intAux, intAux2, 2)
  Next intAux2
Next intAux

Close intNumArch
End Sub


Public Sub AbrirSecuencias(strArchivo As String)
'Lee los datos del archivo de configuracin .bdo "strArchivo"
On Error GoTo ErrorEnAbrirSecuencias
Dim intNumArch, intAux, intAux2 As Integer
Dim strCadenaLeida As String, strAux1 As String, strAux2 As String
intNumArch = FreeFile
Open strArchivo For Input As intNumArch
Input #intNumArch, strCadenaLeida 'Lee el nombre y versin del programa
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strAux1 = App.Major & "." & App.Minor
If App.Revision > 0 Then strAux1 = strAux1 & "." & App.Revision
If (strAux2 <> strAux1) Then
  MsgBox "Este archivo fue creado con una versin diferente del programa. Algunos parmetros pueden no haber sido correctamente cargados, por lo que se recomienda volver a guardarlo.", vbExclamation, "Atencin"
End If
Input #intNumArch, strCadenaLeida 'Lee strIdioma
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strIdioma = strAux2
Input #intNumArch, strCadenaLeida 'Lee strEjecutarAutomaticamente
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strEjecutarAutomaticamente = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnMostrarAyudaAlInicio
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnMostrarAyudaAlInicio = strAux2
Input #intNumArch, strCadenaLeida 'Lee intTiempoBarrido
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intTiempoBarrido = Val(strAux2)
Input #intNumArch, strCadenaLeida 'Lee intTiempoPuntosGrabados
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intTiempoPuntosGrabados = Val(strAux2)
Input #intNumArch, strCadenaLeida 'Lee blnMostrarUbicAlCambiarSec
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnMostrarUbicAlCambiarSec = strAux2
Input #intNumArch, strCadenaLeida 'Lee intCantidadDeSecuencias
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intCantidadDeSecuencias = Val(strAux2)

For intAux = 1 To intCantidadDeSecuencias
  Input #intNumArch, strCadenaLeida 'Lee intCantidadDePuntosSecuencia(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  intCantidadDePuntosSecuencia(intAux) = Val(strAux2)
Next intAux
For intAux = 1 To intCantidadDeSecuencias
  For intAux2 = 1 To intCantidadDePuntosSecuencia(intAux)
    Input #intNumArch, strCadenaLeida 'Lee intPunto(intAux, intAux2, 1)
    SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
    intPunto(intAux, intAux2, 1) = Val(strAux2)
    Input #intNumArch, strCadenaLeida 'Lee intPunto(intAux, intAux2, 2)
    SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
    intPunto(intAux, intAux2, 2) = Val(strAux2)
  Next intAux2
Next intAux

Close intNumArch
Exit Sub

CargaPorDefectoSecuencias:
'Establece valores por defecto
strIdioma = "Espaol"
strEjecutarAutomaticamente = "No*"
blnMostrarAyudaAlInicio = True
intTiempoBarrido = 10
intTiempoPuntosGrabados = 20
blnMostrarUbicAlCambiarSec = False
intCantidadDeSecuencias = 1
Close intNumArch
Exit Sub

ErrorEnAbrirSecuencias:
  Select Case Err.Number
    Case 53, 76 'No existe el archivo
      Resume CargaPorDefectoSecuencias
    Case 62 'El archivo tiene menos lneas que las necesarias
      Resume CargaPorDefectoSecuencias
    Case Else
      Resume CargaPorDefectoSecuencias
  End Select
End Sub



